package cz.muni.cv3networking;

import java.io.IOException;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

public class OkHttpClientExample {

	private static OkHttpClient client;

	public static OkHttpClient getClient() {
		if (client == null) {
			client = new OkHttpClient();
		}

		return client;
	}

	public void synchronousExample() {
		Request request = new Request.Builder()
				.url("https://example.com/files/file.txt")
				.build();

		Call call = getClient().newCall(request);
		try {
			Response response = call.execute();

			if (response.isSuccessful()) {
				System.out.println(response.body().string());
			} else {
				// Response 400 - X
			}
		} catch (IOException e) {
			// cannot connect to server
		}
	}

	public void asynchronousExample() {
		final Request request = new Request.Builder()
				.url("https://example.com/files/file.txt")
				.build();

		Call call = getClient().newCall(request);
		call.enqueue(new Callback() {
			@Override public void onResponse(Call call, Response response) throws IOException {
				if (response.isSuccessful()) {
					System.out.println(response.body().string());
				} else {
					// Response 400 - X
				}
			}

			@Override public void onFailure(Call call, IOException e) {
				// cannot connect to server
			}
		});

	}
}
