package cz.muni.cv3networking;

import okhttp3.OkHttpClient;
import okhttp3.logging.HttpLoggingInterceptor;
import retrofit2.Call;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;
import retrofit2.http.GET;
import retrofit2.http.Path;
import retrofit2.http.Query;

public class RetrofitApi {

	private static final String URL = "http://example.com/v1/";

	public static ServerService serverService;

	public static ServerService get() {
		if (serverService == null) {
			HttpLoggingInterceptor logger = new HttpLoggingInterceptor();
			logger.setLevel(HttpLoggingInterceptor.Level.BODY);

			OkHttpClient client = new OkHttpClient.Builder()
					.addInterceptor(logger)
					.build();

			Retrofit retrofit = new Retrofit.Builder()
					.baseUrl(URL)
					.client(client)
					.addConverterFactory(GsonConverterFactory.create())
					.build();

			serverService = retrofit.create(ServerService.class);
		}

		return serverService;
	}

	public interface ServerService {

		// http://example.com/v1/movies?category=comedy
		@GET("movies")
		Call<Object> getMovies(@Query("category") String category);

		// http://example.com/v1/movies/12331/120
		@GET("movies/{id}/{length}")
		Call<Object> getMovie(@Path("id") long id, @Path("length") long length);
	}
}
